/*
 * Intel ACPI Component Architecture
 * AML/ASL+ Disassembler version 20160729-64
 * Copyright (c) 2000 - 2016 Intel Corporation
 * 
 * Disassembling to symbolic ASL+ operators
 *
 * Disassembly of /Applications/DarwinDumper_3.0.4_28.01_18.15.05_MacBookPro11,3_Apple_X64_High Sierra_17G3025_shall/ACPI Tables/AML/SSDT-2.aml, Mon Jan 28 18:15:31 2019
 *
 * Original Table Header:
 *     Signature        "SSDT"
 *     Length           0x00000688 (1672)
 *     Revision         0x01
 *     Checksum         0x3B
 *     OEM ID           "APPLE "
 *     OEM Table ID     "SDUsbLpt"
 *     OEM Revision     0x00001000 (4096)
 *     Compiler ID      "INTL"
 *     Compiler Version 0x20100915 (537921813)
 */
DefinitionBlock ("", "SSDT", 1, "APPLE ", "SDUsbLpt", 0x00001000)
{
    External (_SB_.PCI0, DeviceObj)
    External (DTGP, MethodObj)    // 5 Arguments
    External (GD10, FieldUnitObj)
    External (GP10, FieldUnitObj)
    External (OSDW, MethodObj)    // 0 Arguments

    Scope (\_SB.PCI0)
    {
        Device (XHC1)
        {
            Name (_ADR, 0x00140000)  // _ADR: Address
            Name (SDPC, 0x00)
            OperationRegion (XH1C, PCI_Config, 0xD0, 0x10)
            Field (XH1C, ByteAcc, NoLock, Preserve)
            {
                PAHC,   1, 
                PCHC,   1, 
                Offset (0x01), 
                PBHC,   1, 
                PDHC,   1, 
                    ,   3, 
                PKHC,   1, 
                Offset (0x08), 
                PASS,   1, 
                PBSS,   1, 
                PCSS,   1, 
                PDSS,   1
            }

            OperationRegion (XH2C, PCI_Config, 0xD0, 0x10)
            Field (XH2C, ByteAcc, NoLock, Preserve)
            {
                PHCA,   14, 
                Offset (0x08), 
                PSSA,   6
            }

            Method (_PRW, 0, NotSerialized)  // _PRW: Power Resources for Wake
            {
                If (OSDW ())
                {
                    Return (Package (0x02)
                    {
                        0x0D, 
                        0x03
                    })
                }
                Else
                {
                    Return (Package (0x02)
                    {
                        0x0D, 
                        0x03
                    })
                }
            }

            Method (_DSM, 4, NotSerialized)  // _DSM: Device-Specific Method
            {
                Local0 = Package (0x09)
                    {
                        "AAPL,current-available", 
                        0x0834, 
                        "AAPL,current-extra", 
                        0x0898, 
                        "AAPL,current-extra-in-sleep", 
                        0x0640, 
                        "AAPL,max-port-current-in-sleep", 
                        0x0834, 
                        Buffer (0x01)
                        {
                             0x00                                             /* . */
                        }
                    }
                DTGP (Arg0, Arg1, Arg2, Arg3, RefOf (Local0))
                Return (Local0)
            }

            Method (XHCA, 0, NotSerialized)
            {
                If (!OSDW ())
                {
                    \_SB.PCI0.XHC1.PASS = 0x01
                }

                \_SB.PCI0.XHC1.PAHC = 0x01
            }

            Method (XHCB, 0, NotSerialized)
            {
                If (!OSDW ())
                {
                    \_SB.PCI0.XHC1.PBSS = 0x01
                }

                \_SB.PCI0.XHC1.PBHC = 0x01
            }

            Method (XHCC, 0, NotSerialized)
            {
                If (!OSDW ())
                {
                    \_SB.PCI0.XHC1.PCSS = 0x01
                }

                \_SB.PCI0.XHC1.PCHC = 0x01
            }

            Method (XHCD, 0, NotSerialized)
            {
                If (!OSDW ())
                {
                    \_SB.PCI0.XHC1.PDSS = 0x01
                }

                \_SB.PCI0.XHC1.PDHC = 0x01
            }

            Method (EHCA, 0, NotSerialized)
            {
                If (!OSDW ())
                {
                    \_SB.PCI0.XHC1.PASS = 0x00
                }

                \_SB.PCI0.XHC1.PAHC = 0x00
            }

            Method (EHCB, 0, NotSerialized)
            {
                If (!OSDW ())
                {
                    \_SB.PCI0.XHC1.PBSS = 0x00
                }

                \_SB.PCI0.XHC1.PBHC = 0x00
            }

            Method (EHCC, 0, NotSerialized)
            {
                If (!OSDW ())
                {
                    \_SB.PCI0.XHC1.PCSS = 0x00
                }

                \_SB.PCI0.XHC1.PCHC = 0x00
            }

            Method (EHCD, 0, NotSerialized)
            {
                If (!OSDW ())
                {
                    \_SB.PCI0.XHC1.PDSS = 0x00
                }

                \_SB.PCI0.XHC1.PDHC = 0x00
            }

            Method (LEGM, 0, NotSerialized)
            {
                If (!OSDW ())
                {
                    \_SB.PCI0.XHC1.PHCA = 0x3FFF
                    \_SB.PCI0.XHC1.PSSA = 0x3F
                    \_SB.PCI0.XHC1.PKHC = 0x00
                }
            }

            Device (RHUB)
            {
                Name (_ADR, 0x00)  // _ADR: Address
                Device (HS01)
                {
                    Name (_ADR, 0x01)  // _ADR: Address
                    Name (_UPC, Package (0x04)  // _UPC: USB Port Capabilities
                    {
                        0xFF, 
                        0x03, 
                        0x00, 
                        0x00
                    })
                    Name (_PLD, Package (0x10)  // _PLD: Physical Location of Device
                    {
                        0x81, 
                        0x00, 
                        0x00, 
                        0x00, 
                        0x00, 
                        0x00, 
                        0x00, 
                        0x00, 
                        0x31, 
                        0x1C, 
                        0x00, 
                        0x00, 
                        0x00, 
                        0x00, 
                        0x00, 
                        0x00
                    })
                    Name (MUXS, "EHCA")
                }

                Device (HS05)
                {
                    Name (_ADR, 0x05)  // _ADR: Address
                    Name (_UPC, Package (0x04)  // _UPC: USB Port Capabilities
                    {
                        0xFF, 
                        0x03, 
                        0x00, 
                        0x00
                    })
                    Name (_PLD, Package (0x10)  // _PLD: Physical Location of Device
                    {
                        0x81, 
                        0x00, 
                        0x00, 
                        0x00, 
                        0x00, 
                        0x00, 
                        0x00, 
                        0x00, 
                        0x31, 
                        0x1C, 
                        0x00, 
                        0x00, 
                        0x00, 
                        0x00, 
                        0x00, 
                        0x00
                    })
                    Name (MUXS, "EHCB")
                }

                Device (HS08)
                {
                    Name (_ADR, 0x08)  // _ADR: Address
                    Name (_UPC, Package (0x04)  // _UPC: USB Port Capabilities
                    {
                        0xFF, 
                        0xFF, 
                        0x00, 
                        0x00
                    })
                    Name (_PLD, Package (0x10)  // _PLD: Physical Location of Device
                    {
                        0x81, 
                        0x00, 
                        0x00, 
                        0x00, 
                        0x00, 
                        0x00, 
                        0x00, 
                        0x00, 
                        0x30, 
                        0x1C, 
                        0x00, 
                        0x00, 
                        0x00, 
                        0x00, 
                        0x00, 
                        0x00
                    })
                }

                Device (HS12)
                {
                    Name (_ADR, 0x0C)  // _ADR: Address
                    Name (_UPC, Package (0x04)  // _UPC: USB Port Capabilities
                    {
                        0xFF, 
                        0xFF, 
                        0x00, 
                        0x00
                    })
                    Name (_PLD, Package (0x10)  // _PLD: Physical Location of Device
                    {
                        0x81, 
                        0x00, 
                        0x00, 
                        0x00, 
                        0x00, 
                        0x00, 
                        0x00, 
                        0x00, 
                        0x30, 
                        0x1C, 
                        0x00, 
                        0x00, 
                        0x00, 
                        0x00, 
                        0x00, 
                        0x00
                    })
                }

                Device (SSP1)
                {
                    Name (_ADR, 0x10)  // _ADR: Address
                    Name (_UPC, Package (0x04)  // _UPC: USB Port Capabilities
                    {
                        0xFF, 
                        0x03, 
                        0x00, 
                        0x00
                    })
                    Name (_PLD, Package (0x10)  // _PLD: Physical Location of Device
                    {
                        0x81, 
                        0x00, 
                        0x00, 
                        0x00, 
                        0x00, 
                        0x00, 
                        0x00, 
                        0x00, 
                        0x31, 
                        0x1C, 
                        0x00, 
                        0x00, 
                        0x00, 
                        0x00, 
                        0x00, 
                        0x00
                    })
                    Name (XHCP, 0x01)
                }

                Device (SSP2)
                {
                    Name (_ADR, 0x11)  // _ADR: Address
                    Name (_UPC, Package (0x04)  // _UPC: USB Port Capabilities
                    {
                        0xFF, 
                        0x03, 
                        0x00, 
                        0x00
                    })
                    Name (_PLD, Package (0x10)  // _PLD: Physical Location of Device
                    {
                        0x81, 
                        0x00, 
                        0x00, 
                        0x00, 
                        0x00, 
                        0x00, 
                        0x00, 
                        0x00, 
                        0x31, 
                        0x1C, 
                        0x00, 
                        0x00, 
                        0x00, 
                        0x00, 
                        0x00, 
                        0x00
                    })
                    Name (XHCP, 0x05)
                }

                Device (SSP4)
                {
                    Name (_ADR, 0x13)  // _ADR: Address
                    Name (_UPC, Package (0x04)  // _UPC: USB Port Capabilities
                    {
                        0xFF, 
                        0xFF, 
                        0x00, 
                        0x00
                    })
                    Name (_PLD, Package (0x10)  // _PLD: Physical Location of Device
                    {
                        0x81, 
                        0x00, 
                        0x00, 
                        0x00, 
                        0x00, 
                        0x00, 
                        0x00, 
                        0x00, 
                        0x31, 
                        0x1C, 
                        0x00, 
                        0x00, 
                        0x00, 
                        0x00, 
                        0x00, 
                        0x00
                    })
                    Method (_RMV, 0, NotSerialized)  // _RMV: Removal Status
                    {
                        Return (0x00)
                    }

                    Name (BERT, 0x0C)
                    Name (IGNR, 0x00)
                    Method (SBHV, 1, Serialized)
                    {
                        If (Arg0)
                        {
                            IGNR = 0x01
                        }
                        Else
                        {
                            IGNR = 0x00
                        }
                    }

                    Method (GBHV, 0, Serialized)
                    {
                        Return (IGNR) /* \_SB_.PCI0.XHC1.RHUB.SSP4.IGNR */
                    }

                    Name (U3SD, 0x7C)
                    Name (S104, 0x0551)
                    Name (S050, 0x0551)
                    Name (S025, 0x0551)
                    Name (_GPE, 0x1E)  // _GPE: General Purpose Events
                }
            }

            Method (XEPC, 0, NotSerialized)
            {
                Return (0x60)
            }

            Method (MBSD, 0, NotSerialized)
            {
                Return (0x01)
            }

            Method (SPWR, 1, Serialized)
            {
                If (Arg0 == 0x00)
                {
                    GD10 = 0x00
                    GP10 = 0x00
                }
                ElseIf (Arg0 == 0x01)
                {
                    GD10 = 0x01
                    SDPC += 0x01
                }
                ElseIf (Arg0 == 0x02)
                {
                    GD10 = 0x00
                    GP10 = 0x00
                }
                ElseIf (Arg0 == 0x03)
                {
                    GD10 = 0x01
                }
            }

            Method (SPWC, 0, NotSerialized)
            {
                Return (SDPC) /* \_SB_.PCI0.XHC1.SDPC */
            }
        }
    }
}

